﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Linq;
using System.Web.UI.HtmlControls;
using System.IO;

namespace JuiceExplorer
{
    public partial class Wijmo : System.Web.UI.MasterPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            BindNavigation();
            BuildCodeView();
            RegisterCallbacks();
        }

        private void BindNavigation()
        {
            //<!--qq-->
            this.navigation.Controls.Clear();

            var ulWidgetList = new HtmlGenericControl("ul");
            ulWidgetList.Attributes["id"] = "widget-list";
            ulWidgetList.Attributes["class"] = "left-nav";
            this.navigation.Controls.Add(ulWidgetList);


            System.Xml.Linq.XElement xEle;
            if (Cache["ControlList"] == null)
            {
                xEle = System.Xml.Linq.XElement.Load(Server.MapPath("~/ControlList.xml"));
                Cache["ControlList"] = xEle;
            }
            else
            {
                xEle = (System.Xml.Linq.XElement)Cache["ControlList"];
            }
            var catalogs = from c in xEle.Elements("Control") select c;
            foreach (System.Xml.Linq.XElement ele in catalogs)
            {
                var ChildControls = ele.Elements("ChildControl");
                if (ChildControls.Count() > 0)
                {
                    var li = new HtmlGenericControl("li");
                    li.Attributes["class"] = "listitem";

                    var linkBtn = new HtmlGenericControl("a");
                    linkBtn.Attributes["href"] = "#";
                    linkBtn.InnerHtml = ele.Attribute("name").Value +
                        "<span class=\"flyout-icon\">&#8250;</span>";
                    //linkBtn.Text = element.Attribute("name").Value;
                    //linkBtn.PostBackUrl = element.Attribute("defaultpage").Value;
                    li.Controls.Add(linkBtn);

                    var subUl = new HtmlGenericControl("ul");
                    subUl.Attributes["id"] = ele.Attribute("name").Value.ToLower() +
                        "-children";
                    subUl.Attributes["class"] = "ui-helper-hidden";

                    foreach (System.Xml.Linq.XElement child in ChildControls)
                    {
                        var childLi = new HtmlGenericControl("li");
                        childLi.Attributes["class"] = "listitem-inner";
                        subUl.Controls.Add(childLi);

                        var childLinkBtn = new HtmlGenericControl("a");
                        var actions = child.Elements("action");
                        if (actions.Count() > 0)
                        {
                            childLinkBtn.Attributes["href"] = ResolveClientUrl(actions.ElementAt(0).Attribute("page").Value);
                        }
                        else
                        {
                            childLinkBtn.Attributes["href"] = "/" + ele.Attribute("name").Value + "/Overview.aspx";
                        }
                        if (child.Attribute("text") != null)
                        {
                            childLinkBtn.InnerHtml = child.Attribute("text").Value;
                        }
                        else
                        {
                            childLinkBtn.InnerHtml = child.Attribute("name").Value;
                        }
                        childLi.Controls.Add(childLinkBtn); ;
                    }
                    li.Controls.Add(subUl);
                    li.Attributes["class"] += " parent-item";
                    ulWidgetList.Controls.Add(li);
                }
                else
                {
                    var li = new HtmlGenericControl("li");
                    li.Attributes["class"] = "listitem wijmo-open";
                    ulWidgetList.Controls.Add(li);

                    var linkBtn = new HtmlGenericControl("a");
                    var actions = ele.Elements("action");
                    if (actions.Count() > 0)
                    {
                        linkBtn.Attributes["href"] = ResolveClientUrl(actions.ElementAt(0).Attribute("page").Value);
                    }
                    else
                    {
                        linkBtn.Attributes["href"] = "/" + ele.Attribute("name").Value + "/Overview.aspx";
                    }
                    linkBtn.InnerHtml = ele.Attribute("name").Value;
                    li.Controls.Add(linkBtn);
                }

            }

            //side-menu



            var relativePaths = Request.AppRelativeCurrentExecutionFilePath.Split('/');
            IEnumerable<XElement> pageList = from control2 in catalogs
                                             where control2.Attribute("name").Value.ToLower() == relativePaths[1].Replace("C1", "").ToLower()
                                             select control2;


            if (pageList != null)
            {
                if (pageList.Count() < 1)
                {
                    var childControls = from c in xEle.Descendants("ChildControl") select c;

                    pageList = from control2 in childControls
                               where control2.Attribute("name").Value.ToLower() == relativePaths[1].Replace("C1", "").ToLower()
                               select control2;
                }
                if (pageList.Count() > 0)
                {

                    this.secondary.Visible = true;
                    this.secondary.Controls.Clear();

                    HtmlGenericControl ulSideMenu = new HtmlGenericControl("ul");
                    ulSideMenu.Attributes["id"] = "side-menu-list";
                    secondary.Controls.Add(ulSideMenu);

                    foreach (XElement action in pageList.First().Elements("action"))
                    {

                        HtmlGenericControl li = new HtmlGenericControl("li");

                        ulSideMenu.Controls.Add(li);
                        HtmlGenericControl link = new HtmlGenericControl("a");
                        link.InnerHtml = action.Attribute("name").Value;
                        link.Attributes["href"] = ResolveClientUrl(action.Attribute("page").Value);
                        li.Controls.Add(link);


                        if (action.Attribute("page").Value.ToLower() == Request.AppRelativeCurrentExecutionFilePath.ToLower())
                        {
                            li.Attributes["class"] = "demo-config-on";
                            Page.Title = action.Parent.Attribute("name").Value + " - " + action.Attribute("name").Value;
                            WidgetNameTitle.InnerHtml = action.Parent.Attribute("name").Value;
                            SampleNameTitle.InnerHtml = action.Attribute("name").Value;

                        }
                    }
                }
            }
            else
            {
                this.secondary.Visible = false;
            }

        }

        private void BuildCodeView()
        {
            string pagePath = Page.MapPath(Request.Url.AbsolutePath);
            string codePath = pagePath + ".cs";

            LblASPX.Text = File.ReadAllText(pagePath);
            LblCS.Text = File.ReadAllText(codePath);

        }
    }
}